import { DOMAttributes, SyntheticEvent, MutableRefObject } from 'react';
declare type HTMLElRef = MutableRefObject<HTMLElement>;
declare type CustomEvent = {
    event?: SyntheticEvent<any, Event>;
    portal: HTMLElRef;
    targetEl: HTMLElement;
};
declare type CustomEventHandler = (customEvent: CustomEvent) => void | HTMLElRef;
declare type CustomEventHandlers = {
    [K in keyof DOMAttributes<K>]?: CustomEventHandler;
};
declare type UsePortalOptions = {
    closeOnOutsideClick?: boolean;
    closeOnEsc?: boolean;
    bindTo?: HTMLElement;
    isOpen?: boolean;
    onOpen?: CustomEventHandler;
    onClose?: CustomEventHandler;
} & CustomEventHandlers;
export default function usePortal({ closeOnOutsideClick, closeOnEsc, bindTo, // attach the portal to this node in the DOM
isOpen: defaultIsOpen, onOpen, onClose, ...eventHandlers }?: UsePortalOptions): any;
export {};
